﻿// 地理院地図のソースをベースにした
// LayerOpacitySetter、SakuzuListItem、SakuzuList、KML、KMLIcon、KMLMarker
// ・不要な処理をコメントアウト。
// ・少し修正。変更箇所は【地理院地図ソース変更】の箇所。

var GSI = {
    //ClientMode: {}
    //, Modal: {}
    //, Draw: {}
    //, Edit: {}
    //, Control: {}
    Utils: {
        Browser: {}
    }
    , GLOBALS: {}
    , TEXT: {}
};

var CONFIG = {};

// GeoJSON 独自パラメータ
CONFIG.GEOJSONSPECIALKEYS = {
    "_markerType": true,

    "_iconUrl": true,
    "_iconSize": true,
    "_iconAnchor": true,
    "_html": true,
    "_radius": true,

    "_className": true,
    "_stroke": true,
    "_radius": true,

    "_dashArray": true,
    "_lineCap": true,
    "_lineJoin": true,
    "_clickable": true,

    "_color": true,
    "_opacity": true,
    "_weight": true,
    "_fill": true,
    "_fillColor": true,
    "_fillOpacity": true,
    "_weight": true

};
/************************************************************************
 設定：文言
 ************************************************************************/
// 作図関連
GSI.TEXT.SAKUZU = {};
GSI.TEXT.SAKUZU.SAKUZUTITLE = '新規作図情報';

/************************************************************************
 GSI.Utils
 ************************************************************************/
GSI.Utils.encodeHTML = function (src) {
    src = src.replace(/&/g, '&amp;');
    src = src.replace(/</g, '&lt;');
    src = src.replace(/>/g, '&gt;');
    return src;
};

/************************************************************************
 L.Class
 - GSI.LayerOpacitySetter（各レイヤーへの不透明度設定）
 ************************************************************************/
GSI.LayerOpacitySetter = L.Class.extend({
    opacity: 1,
    getOpacity: function () {
        return this.opacity;
    },
    setOpacity: function (layer, opacity) {
        this.opacity = opacity;
        this._setLayerOpacity(layer);
    },
    _setLayerOpacity: function (layer) {
        if (!layer) return;

        if (layer.setOpacity) {
            layer.setOpacity(this.opacity);
        }
        else if (layer._icon) {
            $(layer._icon).css({ opacity: this.opacity });
        }
        else if (layer._container) {
            $(layer._container).css({ opacity: this.opacity });
        }

        if (layer.eachLayer) {
            layer.eachLayer(L.bind(this._setLayerOpacity, this));
        }
    }
});

/************************************************************************
 L.Class
 - GSI.SakuzuList（作図リスト管理）
 ************************************************************************/
GSI.SakuzuListItem = L.Class.extend({
    includes: L.Mixin.Events,
    //_title: '',
    //_fileName: '',
    _layer: null,
    initialize: function (owner, dataType, title, fileName, layer, visible) {
        this.editMode = GSI.SakuzuListItem.NONE;
        this._owner = owner;
        this._dataType = dataType;
        this._title = title;
        this._fileName = fileName;
        this._layer = layer;
        this._visible = visible;
        if (!this._layer) this._layer = L.featureGroup();

        if (visible) this._owner._map.addLayer(this._layer);
    },
    getVisible: function () {
        return this._visible;
    },
    setVisible: function (visible) {
        if (this._visible != visible) {
            this._visible = visible;
            if (this._layer) {
                if (this._visible)
                    this._owner._map.addLayer(this._layer);
                else
                    this._owner._map.removeLayer(this._layer);
            }

            this._owner.fire('visiblechange');
        }

    },
    //getTitle: function () {
    //    return this._title;
    //},
    //getFileName: function () {
    //    return this._fileName;
    //},
    _getLayerCount: function (layer) {
        if (!layer) return 0;
        if (!layer.getLayers) return 1;
        var layers = layer.getLayers();

        var result = 0;
        for (var i = 0; i < layers.length; i++) {
            var layer = layers[i];
            var layerType = this._getType(layer);

            if (layerType != GSI.SakuzuListItem.FEATURES)
                result++;
            else {
                result += this._getLayerCount(layer);
            }
        }

        return result;
    },
    getLayerCount: function () {
        return this._getLayerCount(this._layer);
    },
    //remove: function () {
    //    this._owner.remove(this);
    //},
    removeAllLayers: function () {
        if (this._layer) {
            this._owner._map.removeLayer(this._layer);
            delete this._layer;
            this._layer = null;
        }
        this._layer = L.featureGroup();
        this._owner._map.addLayer(this._layer);
    },
    destroy: function () {
        if (this._layer) {
            this._owner._map.removeLayer(this._layer);
            delete this._layer;
            this._layer = null;
        }
    },
    //getEditingStyle: function () {
    //    var style = null;

    //    if (this._editingEditingLayer) {
    //        style = this._editingEditingLayer.options;
    //        if (this._editingEditingLayer.getLayers) {
    //            var layers = this._editingEditingLayer.getLayers();

    //            if (layers.length > 0) {
    //                style = layers[0].options;
    //            }
    //        }
    //    }
    //    else if (this._editingPathList && this._editingPathList.length > 0) {
    //        style = this._editingPathList[0].options.shapeOptions;

    //        style = (style ? style : this._editingPathList[0].options);
    //    }

    //    if (style) {
    //        if (this._editingType == GSI.SakuzuListItem.POLYGON
	//			|| this._editingType == GSI.SakuzuListItem.CIRCLE
	//			|| this._editingType == GSI.SakuzuListItem.MULTIPOLYGON
	//			|| this._editingType == GSI.SakuzuListItem.MULTICIRCLE) {
    //            if (!style.fillColor) style.fillColor = style.color;
    //            if ((style.fillOpacity === null) || (style.fillOpacity === undefined) || (style.fillOpacity === "")) {
    //                style.fillOpacity = style.opacity;
    //            }
    //        }
    //    }
    //    return style;
    //},
    //getEditingInfo: function () {
    //    return this._editingEditingLayerInfo;
    //},
    //setEditingInfo: function (info) {
    //    this._editingEditingLayerInfo = info;
    //},
    //setEditingStyle: function (style) {
    //    var radius = style.radius;
    //    var currentStyle = this.getEditingStyle();
    //    var icon = null;
    //    var iconInfo = style._iconInfo;

    //    if (iconInfo) {
    //        delete style["_iconInfo"];
    //        if (iconInfo.html || iconInfo.html == '') {
    //            var currentIconOptions = $.extend(true, {}, currentStyle.icon.options);
    //            if (currentIconOptions.html == iconInfo.html) return;
    //            currentIconOptions.html = iconInfo.html;
    //            icon = GSI.divIcon(currentIconOptions);
    //        }
    //        else {
    //            var currentIconUrl = "";
    //            var currentIconScale = 1;
    //            var currentIconSize = [20, 20];
    //            var currentIconAnchor = [10, 10];

    //            if (currentStyle.icon) {
    //                currentIconUrl = currentStyle.icon.options.iconUrl;
    //                currentIconScale = currentStyle.icon.options._iconScale;
    //                currentIconSize = currentStyle.icon.options.iconSize;
    //                currentIconAnchor = currentStyle.icon.options.iconAnchor;

    //                if (!currentIconScale) currentIconScale = 1;
    //            }

    //            var iconScale = (iconInfo._iconScale ? iconInfo._iconScale : currentIconScale);

    //            if (currentIconSize) {
    //                currentIconSize[0] = Math.floor(parseFloat(currentIconSize[0]) * (1.0 / parseFloat(currentIconScale)) * parseFloat(iconScale));
    //                currentIconSize[1] = Math.floor(parseFloat(currentIconSize[1]) * (1.0 / parseFloat(currentIconScale)) * parseFloat(iconScale));
    //            }

    //            if (currentIconAnchor) {
    //                currentIconAnchor[0] = Math.floor(parseFloat(currentIconAnchor[0]) * (1.0 / parseFloat(currentIconScale)) * parseFloat(iconScale));
    //                currentIconAnchor[1] = Math.floor(parseFloat(currentIconAnchor[1]) * (1.0 / parseFloat(currentIconScale)) * parseFloat(iconScale));
    //            }

    //            var iconSize = (iconInfo.iconSize ? iconInfo.iconSize : currentIconSize);
    //            var iconAnchor = (iconInfo.iconAnchor ? iconInfo.iconAnchor : currentIconAnchor);

    //            icon = L.icon({
    //                iconUrl: (iconInfo.iconUrl ? iconInfo.iconUrl : currentIconUrl),
    //                iconSize: iconSize,
    //                iconAnchor: iconAnchor,
    //                _iconScale: iconScale
    //            });
    //        }
    //    }

    //    if (this._editingEditingLayer) {
    //        var oldStyle = this._editingEditingLayer.options;
    //        var newStyle = jQuery.extend(true, oldStyle, style);

    //        // marker
    //        if (this._editingEditingLayer.setIcon && icon) {
    //            this._editingEditingLayer.setIcon(icon);
    //        }

    //        // 円
    //        if (radius) {
    //            if (this._editingType == GSI.SakuzuListItem.POINT_CIRCLE) {
    //                this._editingEditingLayer._radius_px = radius;

    //                var o = this._editingEditingLayer;
    //                var vLatLng = o.getLatLng();
    //                radius = GSI.Utils.ConverUnit(GSI.GLOBALS.map, o, radius, "px", "m");
    //            }
    //        }
    //        if (this._editingEditingLayer.setRadius && radius) { this._editingEditingLayer.setRadius(radius); }
    //        if (this._editingEditingLayer._mRadius && radius) { this._editingEditingLayer._mRadius = radius; }

    //        if (radius) {
    //            if (this._editingType == GSI.SakuzuListItem.POINT_CIRCLE) {
    //                if (this._editingPathList.length >= 1) {
    //                    this._editingPathList[0].onZoomEnd();
    //                }
    //            }
    //        }

    //        // その他
    //        if (this._editingEditingLayer.setStyle) {
    //            this._editingEditingLayer.setStyle(newStyle);
    //        }
    //    }

    //    if (this._editingPathList && this._editingPathList.length > 0) {
    //        for (var i = 0; i < this._editingPathList.length; i++) {
    //            // marker
    //            if (icon) {
    //                this._editingPathList[i].setOptions({ icon: icon });
    //                if (this._editingPathList[i]._marker && this._editingPathList[i]._marker.setIcon)
    //                    this._editingPathList[i]._marker.setIcon(icon);
    //            }

    //            // 円
    //            if (this._editingPathList[i].setRadius && radius) this._editingPathList[i].setRadius(radius);

    //            // その他
    //            var newStyle = jQuery.extend(true, this._editingPathList[i].options.shapeOptions, style);
    //            var shape = this._editingPathList[i]._shape;
    //            if (!shape) shape = this._editingPathList[i]._poly;
    //            if (!shape) shape = this._editingPathList[i]._area;

    //            if (shape && shape.setStyle) {
    //                shape.setStyle(newStyle);
    //            }
    //            if (this._editingPathList.setOptions)
    //                this._editingPathList.setOptions({ shapeOptions: newStyle });

    //        }
    //    }
    //},
    //startCreate: function (id) {
    //    this.setVisible(true);
    //    this.editCancel();
    //    this._owner._mapMouse.setClickMoveEnable(false);

    //    this.editMode = GSI.SakuzuListItem.CREATE;

    //    this._editingType = id;

    //    if (!this._editingFreatureGroup) {
    //        this._editingFreatureGroup = L.featureGroup();
    //        this._owner._map.addLayer(this._editingFreatureGroup);
    //    }

    //    if (!this._pathCreatedEventHandler) {
    //        this._pathCreatedEventHandler = L.bind(this._onPathCreated, this);
    //        this._owner._map.on('draw:created', this._pathCreatedEventHandler);
    //    }

    //    this._editingEditingLayerInfo = {
    //        title: null,
    //        description: null,
    //        table: null
    //    };

    //    switch (id) {
    //        case GSI.SakuzuListItem.POINT:
    //            this._startEditPoint();
    //            break;
    //        case GSI.SakuzuListItem.POINT_CIRCLE:
    //            this._startEditPointCircle();
    //            break;
    //        case GSI.SakuzuListItem.POINT_TEXT:
    //            this._startEditPointText();
    //            break;
    //        case GSI.SakuzuListItem.LINESTRING:
    //            this._startEditLineString();
    //            break;
    //        case GSI.SakuzuListItem.POLYGON:
    //            this._startEditPolygon();
    //            break;
    //        case GSI.SakuzuListItem.CIRCLE:
    //            this._startEditCircle();
    //            break;
    //        case GSI.SakuzuListItem.FREEHAND:
    //            this._startEditFreehand();
    //            break;
    //    }
    //},
    //startEdit: function (id, layer) {
    //    this.setVisible(true);
    //    this.editCancel();
    //    this._owner._mapMouse.setClickMoveEnable(false);

    //    this.editMode = GSI.SakuzuListItem.EDIT;

    //    this._editingType = id;

    //    if (!this._editingFreatureGroup) {
    //        this._editingFreatureGroup = L.featureGroup();
    //        this._owner._map.addLayer(this._editingFreatureGroup);
    //    }
    //    if (!layer._information) {
    //        layer._information = this._getLayerInfo(layer);
    //    }
    //    this._editingEditingLayerInfo = $.extend(true, {}, layer._information ? layer._information : {});

    //    this._editingOriginalLayer = layer;

    //    (layer._parent ? layer._parent : this._layer).removeLayer(layer);
    //    this._editingEditingLayer = this._cloneLayer(this._editingType, layer);
    //    this._editingEditingLayerSRC = $.extend(true, {}, this._editingEditingLayer);

    //    this._editingFreatureGroup.addLayer(this._editingEditingLayer);

    //    this._destroyEditEventHandler();
    //    this._destroyEditPathList();

    //    this._startPathEdit();
    //},
    //_cloneLatLngs: function (src) {
    //    var result = [];

    //    for (var i = 0; i < src.length; i++) {
    //        if (src[i].lat) {
    //            result.push(L.latLng(src[i].lat, src[i].lng));
    //        }
    //    }

    //    return result;
    //},
    //_cloneLayer: function (layerType, layer) {
    //    var result = null;
    //    switch (layerType) {
    //        case GSI.SakuzuListItem.POINT:
    //            var iconOptions = $.extend(true, {}, layer.options.icon.options);

    //            var icon = new L.Icon(iconOptions);
    //            result = L.marker(layer.getLatLng(), { icon: icon, draggable: false });
    //            break;

    //        case GSI.SakuzuListItem.POINT_TEXT:
    //            var iconOptions = $.extend(true, {}, layer.options.icon.options);
    //            var icon = new GSI.DivIcon(iconOptions);
    //            result = L.marker(layer.getLatLng(), { icon: icon, draggable: false });
    //            break;

    //        case GSI.SakuzuListItem.POLYGON:
    //            result = L.polygon(this._cloneLatLngs(layer.getLatLngs()), layer.options);
    //            result.feature = layer.feature;
    //            break;

    //        case GSI.SakuzuListItem.LINESTRING:
    //            result = L.polyline(this._cloneLatLngs(layer.getLatLngs()), layer.options);
    //            result.feature = layer.feature;
    //            break;

    //        case GSI.SakuzuListItem.POINT_CIRCLE:
    //        case GSI.SakuzuListItem.CIRCLE:
    //            var latlng = layer.getLatLng();
    //            var radius = layer.getRadius();
    //            var radius_px = null;
    //            if (layerType == GSI.SakuzuListItem.POINT_CIRCLE) {
    //                radius_px = radius;
    //                radius = GSI.Utils.ConverUnit(GSI.GLOBALS.map, layer, radius_px, "px", "m");
    //            }
    //            result = L.circle(latlng, radius, layer.options);
    //            if (radius_px != null) {
    //                result._radius_px = radius_px;
    //            }
    //            break;

    //        case GSI.SakuzuListItem.MULTILINESTRING:
    //        case GSI.SakuzuListItem.MULTIPOINT:
    //        case GSI.SakuzuListItem.MULTIPOLYGON:
    //            result = L.featureGroup();
    //            result.feature = layer.feature;
    //            var layers = layer.getLayers();
    //            for (var i = 0; i < layers.length; i++) {
    //                var childLayerType = this._getType(layers[i]);
    //                var childLayer = this._cloneLayer(childLayerType, layers[i]);
    //                if (childLayer) {
    //                    childLayer._information = null;
    //                    result.addLayer(childLayer);
    //                }
    //            }
    //            break;
    //    }

    //    if (result) {
    //        result._information = layer._information;
    //    }
    //    return result;
    //},
    _getType: function (layer) {
        var itemType = '';

        if (layer.getRadius) {
            // 円
            itemType = GSI.SakuzuListItem.CIRCLE;

            /*
            Circle:setLabelNoHide
            Circle:getLabel
            Circle:_onMarkerAdd
            Circle:_addLabelRevealHandlers
            Circle:_removeLabelRevealHandlers
            Circle:_showLabel
            Circle:_hideLabel
            */
            if ((layer.feature && layer.feature.propertiesl && layer.feature.properties._markerType == "CircleMarker") || (layer.getLabel && layer._showLabel)) {
                itemType = GSI.SakuzuListItem.POINT_CIRCLE;
            }
        }
        else {
            if (layer.getLayers) {
                itemType = GSI.SakuzuListItem.FEATURES;
                if (layer.feature && layer.feature.geometry && layer.feature.geometry.type) {
                    switch (layer.feature.geometry.type) {
                        case "MultiPolygon":
                            itemType = GSI.SakuzuListItem.MULTIPOLYGON;
                            break;

                        case "MultiLineString":
                            itemType = GSI.SakuzuListItem.MULTILINESTRING;
                            break;

                        case "MultiPoint":
                            itemType = GSI.SakuzuListItem.MULTIPOINT;
                            break;
                    }
                }
            }
            else {
                var geoJSON = layer.toGeoJSON();
                switch (geoJSON.geometry.type) {
                    case "Point":
                        // DivIcon判定
                        if (layer.options.icon.options.html || layer.options.icon.options.html == '') {
                            itemType = GSI.SakuzuListItem.POINT_TEXT;
                        }
                        else {
                            itemType = GSI.SakuzuListItem.POINT;
                        }
                        break;

                    case "Polygon":
                        itemType = GSI.SakuzuListItem.POLYGON;
                        break;
                    case "LineString":
                        itemType = GSI.SakuzuListItem.LINESTRING;
                        break;
                }
            }
        }
        return itemType;
    },
    //_onLayerClick: function (layer) {
    //    var itemType = this._getType(layer);
    //    if (itemType != '') {
    //        this._owner.fire('startedit', { itemType: itemType, layer: layer });
    //    }
    //},
    //_getLayers: function (layer, list, parent) {
    //    if (!layer) return;

    //    var layerType = this._getType(layer);

    //    if (layerType != GSI.SakuzuListItem.FEATURES) {
    //        layer._parent = parent;
    //        list.push(layer);
    //    }
    //    else {
    //        var layers = layer.getLayers();
    //        for (var i = 0; i < layers.length; i++)
    //            this._getLayers(layers[i], list, layer);
    //    }
    //},
    //startSelectTarget: function () {
    //    this.setVisible(true);
    //    this._owner._mapMouse.setClickMoveEnable(false);

    //    if (!this._layer) return;

    //    // 選択用rectangle
    //    if (!this._editingBoundsRects) {
    //        this._editingBoundsRects = L.featureGroup().addTo(this._owner._map);
    //    }

    //    var f_fitBounds = false;
    //    var layers = [];
    //    this._getLayers(this._layer, layers);

    //    for (var i = 0; i < layers.length; i++) {
    //        var layer = layers[i];
    //        layer.id = (i + 1);

    //        // ポップアップストップ
    //        if (layer.closePopup) layer.closePopup();
    //        if (layer.unbindPopup) layer.unbindPopup();

    //        // 編集
    //        if (layer._clickEditHandler) {
    //            layer.off('click', layer._clickEditHandler);
    //            delete layer._clickEditHandler;
    //            layer._clickEditHandler = null;
    //        }

    //        layer._clickEditHandler = L.bind(this._onLayerClick, this, layer);

    //        layer.on('click', layer._clickEditHandler);

    //        var rect = null;
    //        var rectStyle = { color: "#ff3333", weight: 2, fill: false, opacity: 1, dashArray: [3, 3] };

    //        if (layer.getRadius) {
    //            var latlng = layer._latlng;
    //            var radius = layer.getRadius();
    //            /*
    //            Circle:setLabelNoHide
    //            Circle:getLabel
    //            Circle:_onMarkerAdd
    //            Circle:_addLabelRevealHandlers
    //            Circle:_removeLabelRevealHandlers
    //            Circle:_showLabel
    //            Circle:_hideLabel
    //            */
    //            if ((layer.feature && layer.feature.propertiesl && layer.feature.properties._markerType == "CircleMarker") || (layer.getLabel && layer._showLabel)) {
    //                rect = new GSI.PixelRectangle(layer.getLatLng(), radius * 2, radius * 2, radius, radius, rectStyle);

    //                radius = GSI.Utils.ConverUnit(GSI.GLOBALS.map, layer, radius, "px", "m");

    //                //f_fitBounds = false;
    //            }
    //            else {
    //                var latRadius = (radius / 40075017 * 360);
    //                var lngRadius = (latRadius / Math.cos(L.LatLng.DEG_TO_RAD * latlng.lat));

    //                rect = L.rectangle(
	//				    new L.LatLngBounds(
	//					    [latlng.lat - latRadius, latlng.lng - lngRadius],
	//					    [latlng.lat + latRadius, latlng.lng + lngRadius]),
	//				    rectStyle);
    //            }
    //        }
    //        else if (layer.getBounds) {
    //            rect = L.rectangle(layer.getBounds(), rectStyle);
    //        }
    //        else {
    //            if (layer.getLatLng) {
    //                var w = 50;
    //                var h = 50;
    //                var anchorX = 25;
    //                var anchorY = 25;
    //                if (layer.options.icon && layer.options.icon.options.iconUrl && layer.options.icon.options.iconSize) {
    //                    w = layer.options.icon.options.iconSize[0] + 8;
    //                    h = layer.options.icon.options.iconSize[1] + 8;
    //                }
    //                else if (layer._icon) {
    //                    w = $(layer._icon).outerWidth(false) + 8;
    //                    h = $(layer._icon).outerHeight(false) + 8;
    //                }

    //                if (layer.options.icon && layer.options.icon.options.iconAnchor) {
    //                    anchorX = layer.options.icon.options.iconAnchor[0] + 4;
    //                    anchorY = layer.options.icon.options.iconAnchor[1] + 4;
    //                }
    //                else if (layer.options.icon && (layer.options.icon.options.html || layer.options.icon.options.html != '')) {
    //                    anchorX = 4;
    //                    anchorY = 4;
    //                }
    //                else {
    //                    anchorX = Math.round(w / 2);
    //                    anchorY = Math.round(h / 2);
    //                }
    //                rect = new GSI.PixelRectangle(layer.getLatLng(), w, h, anchorX, anchorY, rectStyle);
    //            }
    //        }

    //        layer._boundRect = rect;
    //        if (rect) {
    //            rect.id = layer.id;
    //            this._editingBoundsRects.addLayer(rect);
    //        }
    //    }
    //    if (this._editingBoundsRects.getBounds) {
    //        try {
    //            if (f_fitBounds) {
    //                this._owner._map.fitBounds(this._editingBoundsRects.getBounds());
    //            }
    //        }
    //        catch (e) { }
    //    }
    //},
    //_refreshEditingBoundsRects: function () {
    //    // 選択用rectangle
    //    if (!this._editingBoundsRects) {
    //        this._editingBoundsRects = L.featureGroup().addTo(this._owner._map);
    //    }
    //    else {
    //        this._editingBoundsRects.clearLayers();
    //    }

    //    var layers = [];
    //    this._getLayers(this._layer, layers);

    //    for (var i = 0; i < layers.length; i++) {
    //        var layer = layers[i];
    //        layer.id = (i + 1);

    //        var rect = null;
    //        var rectStyle = { color: "#ff3333", weight: 2, fill: false, opacity: 1, dashArray: [3, 3] };

    //        if (layer.getRadius) {
    //            var latlng = layer._latlng;
    //            var radius = layer.getRadius();
    //            /*
    //            Circle:setLabelNoHide
    //            Circle:getLabel
    //            Circle:_onMarkerAdd
    //            Circle:_addLabelRevealHandlers
    //            Circle:_removeLabelRevealHandlers
    //            Circle:_showLabel
    //            Circle:_hideLabel
    //            */
    //            if ((layer.feature && layer.feature.propertiesl && layer.feature.properties._markerType == "CircleMarker") || (layer.getLabel && layer._showLabel)) {
    //                rect = new GSI.PixelRectangle(layer.getLatLng(), radius * 2, radius * 2, radius, radius, rectStyle);

    //                radius = GSI.Utils.ConverUnit(GSI.GLOBALS.map, layer, radius, "px", "m");
    //            }
    //            else {
    //                var latRadius = (radius / 40075017 * 360);
    //                var lngRadius = (latRadius / Math.cos(L.LatLng.DEG_TO_RAD * latlng.lat));

    //                rect = L.rectangle(
	//				    new L.LatLngBounds(
	//					    [latlng.lat - latRadius, latlng.lng - lngRadius],
	//					    [latlng.lat + latRadius, latlng.lng + lngRadius]),
	//				    rectStyle);
    //            }
    //        }
    //        else if (layer.getBounds) {
    //            rect = L.rectangle(layer.getBounds(), rectStyle);
    //        }
    //        else {
    //            if (layer.getLatLng) {
    //                var w = 50;
    //                var h = 50;
    //                var anchorX = 25;
    //                var anchorY = 25;

    //                if (layer.options.icon && layer.options.icon.options.iconUrl && layer.options.icon.options.iconSize) {
    //                    w = layer.options.icon.options.iconSize[0] + 8;
    //                    h = layer.options.icon.options.iconSize[1] + 8;
    //                }
    //                else if (layer._icon) {
    //                    w = $(layer._icon).outerWidth(true) + 8;
    //                    h = $(layer._icon).outerHeight(true) + 8;
    //                }

    //                if (layer.options.icon && layer.options.icon.options.iconAnchor) {
    //                    anchorX = layer.options.icon.options.iconAnchor[0] + 4;
    //                    anchorY = layer.options.icon.options.iconAnchor[1] + 4;
    //                }
    //                else if (layer.options.icon && (layer.options.icon.options.html || layer.options.icon.options.html != '')) {
    //                    anchorX = 4;
    //                    anchorY = 4;
    //                }
    //                else {
    //                    anchorX = Math.round(w / 2);
    //                    anchorY = Math.round(h / 2);
    //                }

    //                rect = new GSI.PixelRectangle(layer.getLatLng(), w, h, anchorX, anchorY, rectStyle);
    //            }
    //        }
    //        layer._boundRect = rect;
    //        if (rect) {
    //            rect.id = layer.id;
    //            this._editingBoundsRects.addLayer(rect);
    //        }
    //    }
    //},
    //_startEditPoint: function () {
    //    // ポイント編集開始
    //    L.drawLocal.draw.handlers.marker.tooltip.start = 'マーカーを置くポイントをクリック';

    //    this._editingPathList = [];

    //    var myiconScale = CONFIG.SAKUZU.SYMBOL.ICON_SCALE;
    //    var myiconSize = this._owner._defaultIcon.size;
    //    var __myIconSize = [
	//		Math.floor(this._owner._defaultIcon.size[0] * myiconScale),
	//		Math.floor(this._owner._defaultIcon.size[1] * myiconScale)
    //    ];
    //    var myiconAnchor = this._owner._defaultIcon.anchor;
    //    var __myiconAnchor = [
	//		Math.floor(this._owner._defaultIcon.anchor[0] * myiconScale),
	//		Math.floor(this._owner._defaultIcon.anchor[1] * myiconScale)
    //    ];

    //    this._owner._defaultIcon.url = CONFIG.SAKUZU.SYMBOL.URL + CONFIG.SAKUZU.SYMBOL.DEFAULTICON;
    //    this._owner._defaultIcon._iconScale = CONFIG.SAKUZU.SYMBOL.ICON_SCALE;

    //    var path = new L.Draw.Marker(this._owner._map, {
    //        edit: { featureGroup: this._editingFreatureGroup },
    //        showLength: false,
    //        icon: L.icon({
    //            iconUrl: this._owner._defaultIcon.url,
    //            iconSize: __myIconSize,
    //            iconAnchor: __myiconAnchor,
    //            _iconScale: CONFIG.SAKUZU.SYMBOL.ICON_SCALE
    //        })
    //    });

    //    path.enable();

    //    this._editingPathList.push(path);
    //},
    //_startEditPointCircle: function () {
    //    L.drawLocal.draw.handlers.circle.tooltip.start = '中心位置をクリックしドラッグしてください';
    //    L.drawLocal.draw.handlers.simpleshape.tooltip.end = 'マウスボタンを離して終了';

    //    this._editingPathList = [];

    //    // デフォルト
    //    var shapeOptions = {
    //        color: '#000000',
    //        fillColor: '#ff0000',
    //        weight: 3,
    //        opacity: 0.5,
    //        fillOpacity: 0.5,
    //        stroke: true,
    //        fill: true,
    //        clickable: true
    //    };

    //    var path = new GSI.Draw.CircleMarker(this._owner._map, {
    //        shapeOptions: shapeOptions,
    //        edit: { featureGroup: this._editingFreatureGroup },
    //        showLength: true
    //    });
    //    path.on('change', L.bind(this._onCircleChange, this));
    //    path.enable();

    //    this._editingPathList.push(path);
    //},
    //_startEditPointText: function () {
    //    // ポイント(テキスト)編集開始
    //    L.drawLocal.draw.handlers.marker.tooltip.start = 'テキストを置くポイントをクリック';

    //    this._editingPathList = [];

    //    var path = new L.Draw.Marker(this._owner._map, {
    //        edit: { featureGroup: this._editingFreatureGroup },
    //        showLength: false,
    //        icon: GSI.divIcon({
    //            className: 'gsi-div-icon',
    //            html: ''
    //        })
    //    });

    //    path.enable();

    //    this._editingPathList.push(path);
    //},
    //_startEditLineString: function () {
    //    // ライン編集開始
    //    L.drawLocal.draw.handlers.polyline.tooltip.start = '開始位置を選択';
    //    L.drawLocal.draw.handlers.polyline.tooltip.cont = '次の位置を選択(最終点を2回クリックして終了)';
    //    L.drawLocal.draw.handlers.polyline.tooltip.end = '次の位置を選択(最終点を2回クリックして終了)';

    //    this._editingPathList = [];

    //    // デフォルト
    //    var shapeOptions = {
    //        color: '#000000',
    //        weight: 3,
    //        stroke: true,
    //        fill: false,
    //        clickable: true
    //    };

    //    var path = new GSI.Draw.Polyline(this._owner._map, {
    //        shapeOptions: shapeOptions,
    //        edit: { featureGroup: this._editingFreatureGroup },
    //        showLength: true
    //    });
    //    path.enable();

    //    this._editingPathList.push(path);

    //},
    //_startEditPolygon: function () {
    //    // ポリゴン編集開始
    //    L.drawLocal.draw.handlers.polygon.tooltip.start = '開始位置を選択';
    //    L.drawLocal.draw.handlers.polygon.tooltip.cont = '次の位置を選択';
    //    L.drawLocal.draw.handlers.polygon.tooltip.end = '次の位置を選択(最終点を2回クリックして終了)';

    //    this._editingPathList = [];

    //    // デフォルト
    //    var shapeOptions = {
    //        color: '#000000',
    //        fillColor: '#ff0000',
    //        weight: 3,
    //        opacity: 0.5,
    //        fillOpacity: 0.5,
    //        stroke: true,
    //        fill: true,
    //        clickable: true
    //    };

    //    var path = new GSI.Draw.Polygon(this._owner._map, {
    //        shapeOptions: shapeOptions,
    //        edit: { featureGroup: this._editingFreatureGroup },
    //        showArea: true,
    //        allowIntersection: false
    //    });
    //    path.enable();

    //    this._editingPathList.push(path);
    //},
    //_startEditCircle: function () {
    //    L.drawLocal.draw.handlers.circle.tooltip.start = '中心位置をクリックしドラッグしてください';
    //    L.drawLocal.draw.handlers.simpleshape.tooltip.end = 'マウスボタンを離して終了';

    //    this._editingPathList = [];

    //    // デフォルト
    //    var shapeOptions = {
    //        color: '#000000',
    //        fillColor: '#ff0000',
    //        weight: 3,
    //        opacity: 0.5,
    //        fillOpacity: 0.5,
    //        stroke: true,
    //        fill: true,
    //        clickable: true
    //    };

    //    var path = new GSI.Draw.Circle(this._owner._map, {
    //        shapeOptions: shapeOptions,
    //        edit: { featureGroup: this._editingFreatureGroup },
    //        showLength: true
    //    });
    //    path.on('change', L.bind(this._onCircleChange, this));
    //    path.enable();

    //    this._editingPathList.push(path);
    //},
    //_startEditFreehand: function () {
    //    L.drawLocal.draw.handlers.simpleshape.tooltip.end = 'マウスボタンを離して終了';

    //    this._editingPathList = [];

    //    // デフォルト
    //    var shapeOptions = {
    //        color: '#000000',
    //        weight: 3,
    //        opacity: 0.5,
    //        stroke: true,
    //        fill: false,
    //        clickable: true
    //    };

    //    var path = new GSI.Draw.FreehandPolyline(this._owner._map, {
    //        shapeOptions: shapeOptions,
    //        edit: { featureGroup: this._editingFreatureGroup },
    //        showLength: true
    //    });
    //    path.enable();

    //    this._editingPathList.push(path);
    //},
    //_onCircleChange: function (event) {
    //    if (this._editingType == GSI.SakuzuListItem.POINT_CIRCLE) {
    //        this._editingEditingLayer_radius_px = event.radius;
    //        if (this._editingEditingLayer) {
    //            this._editingEditingLayer._radius_px = this._editingEditingLayer_radius_px;
    //        }
    //    }
    //    this._owner.fire('circlechange', event);
    //},
    //_onPathCreated: function (event) {
    //    this._editingEditingLayer = event.layer;
    //    if (this._editingType == GSI.SakuzuListItem.POINT_CIRCLE) {
    //        this._editingEditingLayer._radius_px = this._editingEditingLayer_radius_px;
    //    }
    //    this._editingFreatureGroup.addLayer(event.layer);

    //    this._destroyEditEventHandler();
    //    this._destroyEditPathList();

    //    this._startPathEdit();

    //    this._owner.fire('ready');
    //},
    //isReady: function () {
    //    return (this._editingEditingLayer ? true : false);
    //},
    //_startPathEdit: function (targetLayer) {
    //    var clearPathList = false;
    //    var layerType = null;
    //    if (!targetLayer) {
    //        layerType = this._editingType;
    //        clearPathList = true;
    //        targetLayer = this._editingEditingLayer;
    //    }
    //    else {
    //        layerType = this._getType(targetLayer);
    //    }

    //    switch (layerType) {
    //        case GSI.SakuzuListItem.POINT:
    //        case GSI.SakuzuListItem.POINT_TEXT:
    //            var path = new GSI.Edit.Marker(targetLayer, { edit: { featureGroup: this._editingFreatureGroup } });
    //            path.enable();
    //            if (clearPathList) this._editingPathList = [];
    //            this._editingPathList.push(path);
    //            break;

    //        case GSI.SakuzuListItem.FREEHAND:
    //        case GSI.SakuzuListItem.LINESTRING:
    //        case GSI.SakuzuListItem.POLYGON:
    //            var path = new GSI.Edit.Poly(targetLayer, { isPolygon: (layerType == GSI.SakuzuListItem.POLYGON), edit: { featureGroup: this._editingFreatureGroup } });
    //            path.enable();
    //            if (clearPathList) this._editingPathList = [];
    //            this._editingPathList.push(path);
    //            break;

    //        case GSI.SakuzuListItem.POINT_CIRCLE:
    //        case GSI.SakuzuListItem.CIRCLE:
    //            var path = null;
    //            if (layerType == GSI.SakuzuListItem.CIRCLE) { path = new GSI.Edit.Circle(targetLayer, { edit: { featureGroup: this._editingFreatureGroup } }); }
    //            if (layerType == GSI.SakuzuListItem.POINT_CIRCLE) { path = new GSI.Edit.CircleMarker(targetLayer, { edit: { featureGroup: this._editingFreatureGroup }, map: this._owner._map }); }
    //            path.on('change', L.bind(this._onCircleChange, this));
    //            path.enable();
    //            if (clearPathList) this._editingPathList = [];
    //            this._editingPathList.push(path);
    //            break;

    //        case GSI.SakuzuListItem.MULTIPOINT:
    //        case GSI.SakuzuListItem.MULTILINESTRING:
    //        case GSI.SakuzuListItem.MULTIPOLYGON:
    //            var layers = targetLayer.getLayers();
    //            if (clearPathList) this._editingPathList = [];
    //            for (var i = 0; i < layers.length; i++) {
    //                this._startPathEdit(layers[i]);
    //            }
    //            break;
    //    }
    //},
    //editFinish: function () {
    //    this.editFinish_CircleMarker();

    //    if (this.editMode == GSI.SakuzuListItem.NONE) return;

    //    this._editingEditingLayer._parent = (this._editingOriginalLayer ? this._editingOriginalLayer._parent : null);
    //    this._destroyEditPathList();
    //    this._editingFreatureGroup.removeLayer(this._editingEditingLayer);
    //    (this._editingEditingLayer._parent ? this._editingEditingLayer._parent : this._layer).addLayer(this._editingEditingLayer);

    //    if (this._editingOriginalLayer && this._editingOriginalLayer._clickEditHandler) {
    //        this._editingOriginalLayer.off('click', this._editingOriginalLayer._clickEditHandler);
    //        this._editingEditingLayer._clickEditHandler = L.bind(this._onLayerClick, this, this._editingEditingLayer);
    //        this._editingEditingLayer.on('click', this._editingEditingLayer._clickEditHandler);
    //    }

    //    if (this._editingEditingLayer) {
    //        this._editingEditingLayer._information = this._editingEditingLayerInfo;
    //        this._bindPopup(this._editingEditingLayer);
    //    }
    //    this._destroyEditObjects();
    //    if (this.editMode == GSI.SakuzuListItem.EDIT) {
    //        this._refreshEditingBoundsRects();

    //        this._owner._mapMouse.setClickMoveEnable(false);
    //    }
    //    this.editMode = GSI.SakuzuListItem.NONE;
    //    this._owner.fire('change');
    //},
    //editFinish_CircleMarker: function () {
    //    if (this._editingType == GSI.SakuzuListItem.POINT_CIRCLE) {
    //        var o = this._editingEditingLayer;
    //        var vLatLng = o.getLatLng();
    //        var vRadius = o._radius_px;
    //        if (!vRadius) {
    //            vRadius = GSI.Utils.ConverUnit(GSI.GLOBALS.map, o, o.getRadius(), "m", "px");
    //        }

    //        var vOptions = o.options;
    //        var oMarker = new L.circleMarker(vLatLng, vOptions);
    //        oMarker.setRadius(vRadius);

    //        this._editingEditingLayer = oMarker;
    //    }
    //},
    //_bindPopup: function (layer) {
    //    if (layer) {
    //        if (!layer._information) {
    //            layer._information = this._getLayerInfo(layer);
    //        }

    //        var title = layer._information.title;
    //        var description = layer._information.description;

    //        if (!description || description == '')
    //            description = this._infoTable2Description(layer._information.table);

    //        var popupContent = '';
    //        if (title && title != '') {
    //            popupContent = '<h2>' + GSI.Utils.encodeHTML(title) + '</h2>';
    //        }

    //        if (description && description != '') {
    //            popupContent += description;
    //        }

    //        if (popupContent != '') layer.bindPopup(popupContent,
	//				{
	//				    maxWidth: 5000
	//				});
    //    }
    //},
    //editSelectFinish: function () {
    //    this.editCancel();
    //    if (this._layer) {
    //        var layers = this._layer.getLayers();
    //        for (var i = 0; i < layers.length; i++) {
    //            this._bindPopup(layers[i]);
    //        }

    //    }
    //    this._bindPopup();
    //    this._destroyEditSelectObjects();
    //},
    //editCancel: function () {
    //    if (this.editMode == GSI.SakuzuListItem.NONE) return;
    //    var aaa = null;
    //    if (this._editingOriginalLayer) {
    //        (this._editingOriginalLayer._parent ? this._editingOriginalLayer._parent : this._layer).addLayer(this._editingOriginalLayer);
    //        this._editingOriginalLayer = null;
    //    }

    //    this._destroyEditObjects();

    //    if (this.editMode == GSI.SakuzuListItem.EDIT)
    //        this._owner._mapMouse.setClickMoveEnable(false);

    //    this.editMode = GSI.SakuzuListItem.NONE;
    //},
    //removeEditObject: function () {
    //    if (this._editingBoundsRects) {
    //        if (this._editingOriginalLayer && this._editingOriginalLayer._boundRect)
    //            this._editingBoundsRects.removeLayer(this._editingOriginalLayer._boundRect);
    //        if (this._editingEditingLayer && this._editingEditingLayer._boundRect)
    //            this._editingBoundsRects.removeLayer(this._editingEditingLayer._boundRect);
    //    }
    //    this._editingOriginalLayer = null;
    //    this.editCancel();

    //    this._owner.fire('change');
    //},
    //_destroyEditEventHandler: function () {
    //    if (this._pathCreatedEventHandler) {
    //        this._owner._map.off('draw:created', this._pathCreatedEventHandler);
    //        delete this._pathCreatedEventHandler;
    //        this._pathCreatedEventHandler = null;
    //    }
    //},
    //_destroyEditPathList: function () {
    //    if (this._editingPathList) {
    //        for (var i = 0; i < this._editingPathList.length; i++) {
    //            try {
    //                var path = this._editingPathList[i];
    //                path.disable();
    //                delete path;
    //                path = null;
    //                delete this._editingPathList[i];
    //                this._editingPathList[i] = null;
    //            }
    //            catch (e) { }
    //        }

    //        delete this._editingPathList;
    //        this._editingPathList = null;
    //    }
    //},
    //_destroyEditObjects: function () {
    //    this._editingEditingLayerInfo = null;

    //    this._owner._mapMouse.setClickMoveEnable(true);

    //    this._destroyEditEventHandler();
    //    this._destroyEditPathList();

    //    if (this._editingFreatureGroup) {
    //        try {
    //            this._owner._map.removeLayer(this._editingFreatureGroup);
    //            delete this._editingFreatureGroup;
    //        }
    //        catch (e) { }
    //        this._editingFreatureGroup = null;
    //    }

    //    if (this._editingOriginalLayer) {
    //        (this._editingOriginalLayer._parent ? this._editingOriginalLayer._parent : this._layer).removeLayer(this._editingOriginalLayer);
    //        this._editingOriginalLayer = null;
    //    }

    //    if (this._editingEditingLayer) {
    //        delete this._editingEditingLayer;
    //        this._editingEditingLayer = null;
    //    }
    //},
    //_destroyEditSelectObjects: function () {
    //    this._owner._mapMouse.setClickMoveEnable(true);

    //    if (this._editingBoundsRects) {
    //        this._owner._map.removeLayer(this._editingBoundsRects);
    //        delete this._editingBoundsRects;
    //        this._editingBoundsRects = null;
    //    }

    //    var layers = this._layer.getLayers();

    //    for (var i = 0; i < layers.length; i++) {
    //        var layer = layers[i];

    //        // 編集
    //        if (layer._clickEditHandler) {
    //            layer.off('click', layer._clickEditHandler);
    //            delete layer._clickEditHandler;
    //            layer._clickEditHandler = null;
    //        }
    //    }
    //},
    //_infoTable2Description: function (table) {
    //    if (!table) return '';

    //    var trHtml = '';
    //    for (var i = 0; i < table.length; i++) {
    //        var key = table[i].key;
    //        var value = table[i].value;

    //        if (key && key != '') {
    //            if (!value || value == '') {
    //                value = '';
    //            }

    //            trHtml += '<tr><td>' + GSI.Utils.encodeHTML(key) + '</td><td>' + value + '</td></tr>' + '\n';
    //        }
    //    }

    //    if (trHtml != '') {
    //        return '<table>\n' + trHtml + '</table>';
    //    }
    //    else {
    //        return '';
    //    }
    //},
    _getLayerInfo: function (layer, convertToDescription) {
        var result = $.extend(true, {}, layer._information ? layer._information : {});

        if (!layer._information) {
            if (layer.feature && layer.feature.properties) {
                for (var key in layer.feature.properties) {
                    if (key != '' && CONFIG.GEOJSONSPECIALKEYS[key]) continue;

                    var value = layer.feature.properties[key];

                    if ((typeof value != "string") && (typeof value != "number")) continue;

                    if (key == 'name') {
                        result.title = value;
                    }
                    else if (key == 'description') {
                        result.description = value;
                    }
                    else {
                        if (!result.table) result.table = [];
                        result.table.push({ key: key, value: '' + value });
                    }
                }
            }
            else {
                return result;
            }
        }
        if (convertToDescription && !result.description || result.description == '') {
            result.description = this._infoTable2Description(result.table);
        }

        return result;
    },
    toKML: function (styleList) {
        // KML生成
        var data = '';
        var layers = this._layer.getLayers();

        for (var i = 0; i < layers.length; i++) {
            var layer2 = layers[i];
            var itemType = this._getType(layer2);
            var layerData = null;

            switch (itemType) {
                case GSI.SakuzuListItem.POINT:
                    layerData = this._makeKMLPoint(layer2, this._getKMLStyleId(itemType, styleList, layer2));
                    break;
                case GSI.SakuzuListItem.POLYGON:
                case GSI.SakuzuListItem.CIRCLE:
                    layerData = this._makeKMLPolygon(layer2, this._getKMLStyleId(itemType, styleList, layer2));
                    break;
                case GSI.SakuzuListItem.LINESTRING:
                    layerData = this._makeKMLLine(layer2, this._getKMLStyleId(itemType, styleList, layer2));
                    break;
                case GSI.SakuzuListItem.FEATURES:
                    layerData = this._makeKMLFeatures(layer2, styleList);
                    break;
                case GSI.SakuzuListItem.MULTILINESTRING:
                    layerData = this._makeKMLMultiLine(layer2, styleList);
                    break;
                case GSI.SakuzuListItem.MULTIPOLYGON:
                    layerData = this._makeKMLMultiPolygon(layer2, styleList);
                    break;
                case GSI.SakuzuListItem.MULTIPOINT:
                    layerData = this._makeKMLMultiPoint(layer2, styleList);
                    break;
            }

            if (layerData) {
                data += layerData.data;
            }
        }

        var styles = '';

        if (data != '') {
            for (var styleId in styleList) {
                styles += styleList[styleId].text;
            }
        }

        return styles + data;
    },
    _color2kmlColor: function (color, opacity) {
        if (color && color != '' && color.charAt(0) == '#') {
            color = color.slice(1);

            if (color.length == 3) {
                color = color.slice(-1) + color.slice(1, -1) + color.slice(0, 1);
            }
            else if (color.length == 6) {
                color = color.slice(-2) + color.slice(2, -2) + color.slice(0, 2);
            }
        }
        else {
            color = '000000';
        }
        opacity = ('' + opacity.toString(16));
        if (opacity.length == 1) opacity = '0' + opacity;

        color = opacity + '' + color;
        return color;
    },
    _getKMLStyleId: function (itemType, styleList, layer) {
        //#yellowLineGreenPoly
        var styleId = '';

        switch (itemType) {
            case GSI.SakuzuListItem.POINT:
                var iconUrl = layer.options.icon.options.iconUrl;
                var iconSize = layer.options.icon.options.iconSize;
                var iconAnchor = layer.options.icon.options.iconAnchor;
                var iconScale = layer.options.icon.options._iconScale;

                if (!iconScale) iconScale = 1;
                var hotSpot = {
                    x: Math.round((iconAnchor[0] / iconSize[0]) * 10) / 10,
                    y: Math.round((iconAnchor[1] / iconSize[1]) * 10) / 10,
                };
                styleId = this._findKMLStyle(styleList, itemType, {
                    iconUrl: iconUrl,
                    iconScale: iconScale,
                    hotSpot: hotSpot.x + ',' + hotSpot.y
                });

                if (!styleId) {
                    styleId = 'PolyStyle' + this._owner.getStyleId();

                    var text =
						'<Style id="' + styleId + '">\n' +
						'  <IconStyle>\n' +
						'  <Icon>\n' +
						'  <href>' + iconUrl + '</href>\n' +
						'  </Icon>\n' +
						'  <scale>' + iconScale + '</scale>\n';

                    if (hotSpot.x != 0.5 || hotSpot.y != 0.5) {
                        text +=
							'  <hotSpot x="' + hotSpot.x + '" y="' + hotSpot.y + '" xunits="fraction" yunits="fraction" />\n';
                    }
                    text +=
						'  </IconStyle>\n' +
						'</Style>\n';
                    styleList[styleId] = {
                        type: itemType,
                        text: text,
                        style: {
                            iconUrl: iconUrl,
                            iconScale: iconScale,
                            hotSpot: hotSpot.x + ',' + hotSpot.y
                        }
                    };
                }

                break;

            case GSI.SakuzuListItem.POLYGON:
            case GSI.SakuzuListItem.CIRCLE:

                var color = layer.options.color;
                var opacity = Math.floor((layer.options.opacity || layer.options.opacity == 0 ? layer.options.opacity : 1) * 255);
                var weight = layer.options.weight;
                var fillColor = layer.options.fillColor;

                if (!fillColor) fillColor = color;
                var fillOpacity = Math.floor((layer.options.fillOpacity || layer.options.fillOpacity == 0 ? layer.options.fillOpacity : 1) * 255);
                color = this._color2kmlColor(color, opacity);
                fillColor = this._color2kmlColor(fillColor, fillOpacity);

                styleId = this._findKMLStyle(styleList, itemType, {
                    color: color,
                    weight: weight,
                    fillColor: fillColor
                });

                if (!styleId) {
                    styleId = 'PolyStyle' + this._owner.getStyleId();

                    var text =
						'<Style id="' + styleId + '">\n' +
						'  <LineStyle>\n' +
						'  <color>' + color + '</color>\n' +
						'  <width>' + weight + '</width>\n' +
						'  </LineStyle>\n' +
						'  <PolyStyle>\n' +
						'  <color>' + fillColor + '</color>\n' +
						'  </PolyStyle>\n' +
						'</Style>\n';
                    styleList[styleId] = {
                        type: itemType,
                        text: text,
                        style: {
                            color: color,
                            weight: weight,
                            fillColor: fillColor
                        }
                    };
                }
                break;

            case GSI.SakuzuListItem.LINESTRING:
                var color = layer.options.color;
                var opacity = Math.floor((layer.options.opacity || layer.options.opacity == 0 ? layer.options.opacity : 1) * 255);
                var weight = layer.options.weight;
                color = this._color2kmlColor(color, opacity);

                if (opacity.length == 1) opacity = '0' + opacity;

                styleId = this._findKMLStyle(styleList, itemType, {
                    color: color,
                    weight: weight
                });

                if (!styleId) {
                    styleId = 'LineStyle' + this._owner.getStyleId();

                    var text =
						'<Style id="' + styleId + '">\n' +
						'  <LineStyle>\n' +
						'  <color>' + color + '</color>\n' +
						'  <width>' + weight + '</width>\n' +
						'  </LineStyle>\n' +
						'</Style>\n';
                    styleList[styleId] = {
                        type: itemType,
                        text: text,
                        style: {
                            color: color,
                            weight: weight
                        }
                    };
                }
                break;
        }

        return styleId;
    },
    _findKMLStyle: function (styleList, itemType, style) {
        var id = null;
        for (var key in styleList) {
            var styleData = styleList[key];

            if (styleData.type = itemType) {
                var hit = true;
                for (var key2 in style) {
                    if (styleData.style[key2] != style[key2]) {
                        hit = false;
                        break;
                    }
                }

                if (hit) {
                    id = key;
                    break;
                }

            }
        }

        return id;
    },
    //_makeKMLFeatures: function (layer, styleList) {
    //    var result = {
    //        data: ''
    //    };
    //    var layers = layer.getLayers();

    //    for (var i = 0; i < layers.length; i++) {
    //        var layer2 = layers[i];
    //        var itemType = this._getType(layer2);
    //        var layerData = null;

    //        switch (itemType) {
    //            case GSI.SakuzuListItem.POINT:
    //                layerData = this._makeKMLPoint(layer2, this._getKMLStyleId(itemType, styleList, layer2));
    //                if (layerData) result.data += layerData.data;
    //                break;
    //            case GSI.SakuzuListItem.POLYGON:
    //            case GSI.SakuzuListItem.CIRCLE:
    //                layerData = this._makeKMLPolygon(layer2, this._getKMLStyleId(itemType, styleList, layer2));
    //                if (layerData) result.data += layerData.data;
    //                break;
    //            case GSI.SakuzuListItem.LINESTRING:
    //                layerData = this._makeKMLLine(layer2, this._getKMLStyleId(itemType, styleList, layer2));
    //                if (layerData) result.data += layerData.data;
    //                break;
    //            case GSI.SakuzuListItem.FEATURES:
    //            case GSI.SakuzuListItem.MULTILINESTRING:
    //            case GSI.SakuzuListItem.MULTIPOLYGON:
    //            case GSI.SakuzuListItem.MULTIPOINT:
    //                layerData = this._makeKMLFeatures(layer2, styleList);
    //                if (layerData) {
    //                    result.data += layerData.data;
    //                    result.data = '<Folder>\n' + data + '</Folder>\n';
    //                }
    //                break;
    //        }
    //    }
    //    if (result.data != '') {
    //        result.data = '<Folder>\n' + result.data + '</Folder>\n';
    //    }

    //    return result;
    //},
    //_makeKMLMultiPolygon: function (layer, styleList) {
    //    var info = this._getLayerInfo(layer, false);
    //    var result = {
    //        data: ''
    //    };
    //    var layerId = '';
    //    var layers = layer.getLayers();

    //    for (var i = 0; i < layers.length; i++) {
    //        var layer2 = layers[i];

    //        var itemType = this._getType(layer2);
    //        var layerData = null;
    //        if (itemType == GSI.SakuzuListItem.POLYGON) {
    //            if (layerId == '')
    //                layerId = this._getKMLStyleId(itemType, styleList, layer2);
    //            layerData = this._makeKMLPolygon(layer2, layerId, info);
    //            if (layerData) result.data += layerData.data;
    //        }
    //    }

    //    if (result.data != '') {
    //        result.data = '<Folder>\n' + result.data + '</Folder>\n';
    //    }

    //    return result;
    //},
    //_makeKMLMultiLine: function (layer, styleList) {
    //    var info = this._getLayerInfo(layer, false);
    //    var result = {
    //        data: ''
    //    };
    //    var layerId = '';
    //    var layers = layer.getLayers();

    //    for (var i = 0; i < layers.length; i++) {
    //        var layer2 = layers[i];
    //        var itemType = this._getType(layer2);
    //        var layerData = null;

    //        if (itemType == GSI.SakuzuListItem.LINESTRING) {
    //            if (layerId == '')
    //                layerId = this._getKMLStyleId(itemType, styleList, layer2);
    //            layerData = this._makeKMLLine(layer2, layerId, info);
    //            if (layerData) result.data += layerData.data;
    //        }
    //    }

    //    if (result.data != '') {
    //        result.data = '<Folder>\n' + result.data + '</Folder>\n';
    //    }

    //    return result;
    //},
    //_makeKMLMultiPoint: function (layer, styleList) {
    //    var info = this._getLayerInfo(layer, false);
    //    var result = {
    //        data: ''
    //    };
    //    var layerId = '';
    //    var layers = layer.getLayers();

    //    for (var i = 0; i < layers.length; i++) {
    //        var layer2 = layers[i];
    //        var itemType = this._getType(layer2);
    //        var layerData = null;

    //        if (itemType == GSI.SakuzuListItem.POINT) {
    //            if (layerId == '')
    //                layerId = this._getKMLStyleId(itemType, styleList, layer2);
    //            layerData = this._makeKMLPoint(layer2, layerId, info);
    //            if (layerData) result.data += layerData.data;
    //        }
    //    }

    //    if (result.data != '') {
    //        result.data = '<Folder>\n' + result.data + '</Folder>\n';
    //    }

    //    return result;
    //},
    _makeKMLPoint: function (layer, styleId, info) {
        var latLng = layer.getLatLng();

        if (!info) info = this._getLayerInfo(layer, false);

        var title = info.title;
        var description = info.description;
        var table = info.table;

        if (description) {
            description = description.replace(/[\n\r]/g, '');
        }
        else if (table && table.length > 0) {
            description = this._infoTable2Description(table);
            description = description.replace(/[\n\r]/g, '');
            table = JSON.stringify(table);
        }

        var result = {
            data: ''
        };

        result.data = '<Placemark>\n';

        if (title && title != '')
            result.data += '<name>' + GSI.Utils.encodeHTML(title) + '</name>' + '\n';

        if (description && description != '')
            result.data += '<description><![CDATA[ ' + description + ' ]]></description>' + '\n';

        result.data +=
			'<styleUrl>#' + styleId + '</styleUrl>' + '\n' +
			'<Point>\n' +
			'<coordinates>';

        result.data += latLng.lng + "," + latLng.lat; // + "\n";

        result.data +=
        '</coordinates>\n' +
        '</Point>\n' +
        '</Placemark>\n';
        return result;
    },
    _makeKMLPolygon: function (layer, styleId, info) {
        var latLngs = null;

        if (layer.getRadius) {
            // 円→ポリゴン
            latLngs = [];
            var numSides = 80;
            var degreeStep = 360 / numSides;
            var center = layer.getLatLng();
            var latRadius = layer._getLatRadius();
            var lngRadius = layer._getLngRadius();

            for (var i = 0; i < numSides; i++) {
                var rad = (degreeStep * i) * Math.PI / 180;

                var x = center.lng + (Math.sin(rad) * lngRadius);
                var y = center.lat + (Math.cos(rad) * latRadius);
                latLngs.push(L.latLng(y, x));
            }
        }
        else {
            latLngs = layer.getLatLngs();
        }

        if (!info) info = this._getLayerInfo(layer, false);
        var title = info.title;
        var description = info.description;
        var table = info.table;
        if (description) {
            description = description.replace(/[\n\r]/g, '');
        }
        else if (table && table.length > 0) {
            description = this._infoTable2Description(table);
            description = description.replace(/[\n\r]/g, '');
            table = JSON.stringify(table);
        }

        var result = {
            style: '',
            data: ''
        };

        result.data = '<Placemark>\n';

        if (title && title != '')
            result.data += '<name>' + GSI.Utils.encodeHTML(title) + '</name>' + '\n';

        if (description && description != '')
            result.data += '<description><![CDATA[ ' + description + ' ]]></description>' + '\n';

        result.data +=
			'<styleUrl>#' + styleId + '</styleUrl>' + '\n' +
			'<Polygon>' + '\n' +
			'<outerBoundaryIs>' + '\n' +
			'<LinearRing>' + '\n' +
			'<coordinates>';

        for (var i = 0; i < latLngs.length; i++) {
            result.data += (i > 0 ? ' ' : '') + latLngs[i].lng + "," + latLngs[i].lat;
        }
        // close polygon
        if (latLngs.length > 0) {
            result.data += ' ' + latLngs[0].lng + "," + latLngs[0].lat;
        }

        result.data += '</coordinates>\n' +
		'</LinearRing>' + '\n' +
		'</outerBoundaryIs>' + '\n' +
		'</Polygon>\n' +
		'</Placemark>\n';

        return result;
    },
    //_makeKMLLine: function (layer, styleId, info) {
    //    var latLngs = layer.getLatLngs();

    //    if (!info) info = this._getLayerInfo(layer, false);

    //    var title = info.title;
    //    var description = info.description;
    //    var table = info.table;
    //    if (description) {
    //        description = description.replace(/[\n\r]/g, '');
    //    }
    //    else if (table && table.length > 0) {
    //        description = this._infoTable2Description(table);
    //        description = description.replace(/[\n\r]/g, '');
    //        table = JSON.stringify(table);
    //    }
    //    var result = {
    //        style: '',
    //        data: ''
    //    };

    //    result.data = '<Placemark>\n';

    //    if (title && title != '')
    //        result.data += '<name>' + GSI.Utils.encodeHTML(title) + '</name>' + '\n';

    //    if (description && description != '')
    //        result.data += '<description><![CDATA[ ' + description + ' ]]></description>' + '\n';

    //    result.data +=
	//		'<styleUrl>#' + styleId + '</styleUrl>' + '\n' +
	//		'<LineString>' + '\n' +
	//		'<coordinates>';

    //    for (var i = 0; i < latLngs.length; i++) {
    //        result.data += (i > 0 ? ' ' : '') + latLngs[i].lng + "," + latLngs[i].lat;

    //    }
    //    result.data += '</coordinates>\n' +
	//	'</LineString>\n' +
	//	'</Placemark>\n';

    //    return result;
    //},
    //toGeoJSON: function () {
    //    // GeoJSON生成
    //    var features = [];
    //    var layers = this._layer.getLayers();

    //    for (var i = 0; i < layers.length; i++) {
    //        var layer = layers[i];
    //        var itemType = this._getType(layer);
    //        var geoJSONData = null;

    //        switch (itemType) {
    //            case GSI.SakuzuListItem.POINT:
    //            case GSI.SakuzuListItem.POINT_TEXT:
    //            case GSI.SakuzuListItem.MULTIPOINT:
    //                geoJSONData = this._makeGeoJSONPoint(layer);
    //                if (geoJSONData) features.push(geoJSONData);
    //                break;

    //            case GSI.SakuzuListItem.POLYGON:
    //            case GSI.SakuzuListItem.MULTIPOLYGON:
    //                geoJSONData = this._makeGeoJSONPolygon(layer);
    //                if (geoJSONData) features.push(geoJSONData);
    //                break;

    //            case GSI.SakuzuListItem.LINESTRING:
    //            case GSI.SakuzuListItem.MULTILINESTRING:
    //                geoJSONData = this._makeGeoJSONLine(layer);
    //                if (geoJSONData) features.push(geoJSONData);
    //                break;

    //            case GSI.SakuzuListItem.CIRCLE:
    //            case GSI.SakuzuListItem.POINT_CIRCLE:
    //                geoJSONData = this._makeGeoJSONCircle(layer);
    //                if (itemType == GSI.SakuzuListItem.POINT_CIRCLE) {
    //                    geoJSONData.properties["_markerType"] = "CircleMarker";
    //                }
    //                if (geoJSONData) features.push(geoJSONData);
    //                break;

    //            case GSI.SakuzuListItem.FEATURES:
    //                this._makeGeoJSONFeatures(layer, features);
    //                break;
    //        }
    //    }

    //    return features;
    //},
    //_makeGeoJSONFeatures: function (layer, features) {
    //    try {
    //        var layers = layer.getLayers();

    //        for (var i = 0; i < layers.length; i++) {
    //            var layer2 = layers[i];
    //            var itemType = this._getType(layer2);
    //            var geoJSONData = null;

    //            switch (itemType) {
    //                case GSI.SakuzuListItem.POINT:
    //                case GSI.SakuzuListItem.POINT_TEXT:
    //                    geoJSONData = this._makeGeoJSONPoint(layer2);
    //                    if (geoJSONData) features.push(geoJSONData);
    //                    break;
    //                case GSI.SakuzuListItem.CIRCLE:
    //                case GSI.SakuzuListItem.POINT_CIRCLE:
    //                    geoJSONData = this._makeGeoJSONCircle(layer2);
    //                    if (itemType == GSI.SakuzuListItem.POINT_CIRCLE) {
    //                        geoJSONData.properties["_markerType"] = "CircleMarker";
    //                    }
    //                    if (geoJSONData) features.push(geoJSONData);
    //                    break;
    //                case GSI.SakuzuListItem.POLYGON:
    //                    geoJSONData = this._makeGeoJSONPolygon(layer2);
    //                    if (geoJSONData) features.push(geoJSONData);
    //                    break;
    //                case GSI.SakuzuListItem.LINESTRING:
    //                    geoJSONData = this._makeGeoJSONLine(layer2);
    //                    if (geoJSONData) features.push(geoJSONData);
    //                    break;
    //                case GSI.SakuzuListItem.FEATURES:
    //                    this._makeGeoJSONFeatures(layer, features);
    //                    break;
    //            }
    //        }
    //    }
    //    catch (e) { }
    //},
    //_layerInfo2Properties: function (info) {
    //    if (!info) return {};
    //    var result = {};

    //    if (info.title && info.title != '')
    //        result['name'] = info.title;
    //    if (info.description && info.description != '') {
    //        result['description'] = info.description;
    //    }
    //    else if (info.table) {
    //        for (var i = 0; i < info.table.length; i++) {
    //            result[info.table[i].key] = info.table[i].value;
    //        }
    //    }

    //    return result;
    //},
    //_makeGeoJSONLine: function (layer) {
    //    var result = layer.toGeoJSON();

    //    result.properties = this._layerInfo2Properties(this._getLayerInfo(layer));

    //    var options = layer.options;
    //    if (!options && layer.getLayers) {
    //        var layers = layer.getLayers();
    //        if (layers.length > 0) {
    //            options = layers[0].options;
    //        }
    //    }

    //    var color = options.color;
    //    var opacity = (options.opacity || options.opacity == 0 ? options.opacity : 1);
    //    var weight = options.weight;

    //    result.properties["_color"] = color;
    //    result.properties["_opacity"] = opacity;
    //    result.properties["_weight"] = parseInt(weight);

    //    if (layer.feature && layer.feature.properties) {
    //        for (var key in layer.feature.properties) {
    //            if (CONFIG.GEOJSONSPECIALKEYS[key]) {
    //                key = key.slice(1);
    //                if (!result.properties["_" + key])
    //                    result.properties["_" + key] = options[key];
    //            }
    //        }

    //    }
    //    return result;
    //},
    //_makeGeoJSONCircle: function (layer) {
    //    var result = layer.toGeoJSON();

    //    result.properties = this._layerInfo2Properties(this._getLayerInfo(layer));

    //    var options = layer.options;
    //    if (!options && layer.getLayers) {
    //        var layers = layer.getLayers();
    //        if (layers.length > 0) {
    //            options = layers[0].options;
    //        }
    //    }
    //    var color = options.color;
    //    var opacity = (options.opacity || options.opacity == 0 ? options.opacity : 1);
    //    var weight = options.weight;

    //    var fillColor = options.fillColor;
    //    var fillOpacity = (options.fillOpacity || options.fillOpacity == 0 ? options.fillOpacity : 1);

    //    result.properties["_markerType"] = "Circle";
    //    result.properties["_color"] = color;
    //    result.properties["_opacity"] = opacity;
    //    result.properties["_weight"] = parseInt(weight);
    //    result.properties["_fillColor"] = fillColor;
    //    result.properties["_fillOpacity"] = fillOpacity;
    //    result.properties["_radius"] = parseFloat(parseFloat(layer.getRadius()).toFixed(1));

    //    if (layer.feature && layer.feature.properties) {
    //        for (var key in layer.feature.properties) {
    //            if (CONFIG.GEOJSONSPECIALKEYS[key]) {
    //                key = key.slice(1);
    //                if (!result.properties["_" + key]) {
    //                    result.properties["_" + key] = options[key];
    //                }
    //            }
    //        }
    //    }

    //    return result;
    //},
    //_makeGeoJSONPoint: function (layer) {
    //    var result = layer.toGeoJSON();
    //    result.properties = this._layerInfo2Properties(this._getLayerInfo(layer));

    //    var options = layer.options;
    //    if (!options && layer.getLayers) {
    //        var layers = layer.getLayers();
    //        if (layers.length > 0) {
    //            options = layers[0].options;
    //        }
    //    }

    //    var iconUrl = options.icon.options.iconUrl;
    //    var iconSize = options.icon.options.iconSize;
    //    var iconAnchor = options.icon.options.iconAnchor;
    //    var html = options.icon.options.html;
    //    if (options.icon.options.className == 'gsi-div-icon') {
    //        result.properties["_markerType"] = "DivIcon";
    //        result.properties["_html"] = (html || html != '' ? html : '　');
    //    }
    //    else {
    //        result.properties["_markerType"] = "Icon";
    //        result.properties["_iconUrl"] = iconUrl;
    //    }
    //    result.properties["_iconSize"] = iconSize;
    //    result.properties["_iconAnchor"] = iconAnchor;

    //    if (!result.properties["_iconSize"]) delete result.properties["_iconSize"];

    //    if (!result.properties["_iconAnchor"]) delete result.properties["_iconAnchor"];

    //    if (layer.feature && layer.feature.properties) {
    //        for (var key in layer.feature.properties) {
    //            if (CONFIG.GEOJSONSPECIALKEYS[key]) {
    //                key = key.slice(1);
    //                if (!result.properties["_" + key]) {
    //                    result.properties["_" + key] = options.icon.options[key];
    //                }
    //            }
    //        }
    //    }

    //    return result;
    //},
    //_makeGeoJSONPolygon: function (layer) {
    //    var result = layer.toGeoJSON();

    //    result.properties = this._layerInfo2Properties(this._getLayerInfo(layer));

    //    var options = layer.options;
    //    if (!options && layer.getLayers) {
    //        var layers = layer.getLayers();
    //        if (layers.length > 0) {
    //            options = layers[0].options;
    //        }
    //    }

    //    if (!options) options = {};

    //    var color = options.color;
    //    var opacity = (options.opacity || options.opacity == 0 ? options.opacity : 1);
    //    var weight = options.weight;
    //    var fillColor = options.fillColor;
    //    var fillOpacity = (options.fillOpacity || options.fillOpacity == 0 ? options.fillOpacity : 1);

    //    if (!fillColor) fillColor = color;

    //    result.properties["_color"] = color;
    //    result.properties["_opacity"] = opacity;
    //    result.properties["_weight"] = parseInt(weight);
    //    result.properties["_fillColor"] = fillColor;
    //    result.properties["_fillOpacity"] = fillOpacity;

    //    if (layer.feature && layer.feature.properties) {
    //        for (var key in layer.feature.properties) {
    //            if (CONFIG.GEOJSONSPECIALKEYS[key]) {
    //                key = key.slice(1);
    //                if (!result.properties["_" + key])
    //                    result.properties["_" + key] = options[key];
    //            }
    //        }
    //    }

    //    return result;
    //}
});

GSI.SakuzuListItem.GEOJSON = 1;
GSI.SakuzuListItem.KML = 2;

GSI.SakuzuListItem.NONE = 0;
GSI.SakuzuListItem.CREATE = 1;
GSI.SakuzuListItem.EDIT = 2;

GSI.SakuzuListItem.POINT = "point";
GSI.SakuzuListItem.POINT_CIRCLE = "point_circle";
GSI.SakuzuListItem.POINT_TEXT = "point_text";
GSI.SakuzuListItem.LINESTRING = "line";
GSI.SakuzuListItem.POLYGON = "polygon";
GSI.SakuzuListItem.CIRCLE = "circle";
GSI.SakuzuListItem.FREEHAND = "freehand";
GSI.SakuzuListItem.FEATURES = "features";

GSI.SakuzuListItem.MULTIPOINT = "multipoint";
GSI.SakuzuListItem.MULTILINESTRING = "multiline";
GSI.SakuzuListItem.MULTIPOLYGON = "multipolygon";

GSI.SakuzuList = L.Class.extend({

    includes: L.Mixin.Events,
    _list: [],
    initialize: function (map, mapMouse, defaultIcon, options)
    {
        this._map = map;
        this._mapMouse = mapMouse;
        // ↓値をコピー
        this._defaultIcon = $.extend(true, {}, defaultIcon);
        // 作図データ
        if (options.defaultList && options.defaultList.length > 0) {
            for (var i = 0; i < options.defaultList.length; i++) {
                var fileName = (i == 0 ? GSI.TEXT.SAKUZU.SAKUZUTITLE : options.defaultList[i].fileName);
                var noExt = (i == 0);

                var geoJSON = {
                    "type": "FeatureCollection",
                    "features": options.defaultList[i].features
                };
                var item = this._loadJSON(fileName, geoJSON, options.defaultList[i], noExt);

                if (i == 0 && !item) {
                    this._list.push(new GSI.SakuzuListItem(this, null, GSI.TEXT.SAKUZU.SAKUZUTITLE, '', null, true));
                }
                if (!options.defaultList[i].visible) {
                    item.setVisible(false);
                }
            }
        }
        else {
            this._list.push(new GSI.SakuzuListItem(this, null, GSI.TEXT.SAKUZU.SAKUZUTITLE, '', null, true));
        }
    },
    getSakuzuItem: function () {
        return this._list[0];
    },
    //eachItems: function (fnc) {
    //    for (var i = 0; i < this._list.length; i++) {
    //        fnc(this._list[i]);
    //    }
    //},
    getLength: function () {
        return this._list.length;
    },
    get: function (idx) {
        return this._list[idx];
    },
    //remove: function (obj) {
    //    for (var i = 0; i < this._list.length; i++) {
    //        if (this._list[i] == obj) {
    //            this.removeByIndex(i);
    //            break;
    //        }
    //    }
    //},
    removeByIndex: function (idx) {
        if (idx == 0) {
            this._list[idx].removeAllLayers();
        }
        else {
            this._list[idx].destroy();
            this._list.splice(idx, 1);
        }

        this.fire('change');
    },
    //loadFromFile: function (files) {
    //    if (files && files.length > 0) {
    //        this._fileReader = new FileReader();
    //        this._fileReader.onload = L.bind(this._onFileLoad, this, files[0].name);
    //        this._fileReader.onerror = function () { alert(GSI.TEXT.SAKUZU.LOAD_ERROR); };
    //        this._fileReader.readAsText(files[0]);
    //    }
    //    else {
    //        alert(GSI.TEXT.SAKUZU.LOAD_NOFILE);
    //    }
    //},
    //loadFromText: function (text, fileName) {
    //    var item = null;
    //    try {
    //        var json = JSON.parse(text);
    //        item = this._loadJSON(fileName, json);
    //    }
    //    catch (e) {
    //        try {
    //            item = this._loadKML(fileName, text);
    //        }
    //        catch (e) { }
    //    }

    //    try {
    //        if (item && item._layer && item._layer.getBounds) this._map.fitBounds(item._layer.getBounds());
    //    }
    //    catch (e) { }

    //    this.fire('load', { error: (item ? false : true) });
    //    this.fire('change');
    //},
    //_onFileLoad: function (fileName) {
    //    var item = null;
    //    try {
    //        var json = JSON.parse(this._fileReader.result);

    //        item = this._loadJSON(fileName, json);
    //    }
    //    catch (e) {
    //        try {
    //            item = this._loadKML(fileName);
    //        }
    //        catch (e) { }
    //    }

    //    try {
    //        if (item && item._layer && item._layer.getBounds) this._map.fitBounds(item._layer.getBounds());
    //    }
    //    catch (e) { }

    //    this.fire('load', { error: (item ? false : true) });
    //    this.fire('change');
    //},
    //_loadJSON: function (fileName, json, noExt) {
    //    var layer = new GSI.GeoJSON(null);
    //    layer.addData(json);
    //    if (!fileName) {
    //        fileName = "file-" + this._list.length + ".geojson";
    //    }
    //    else if (!noExt && !fileName.match(/\./)) {
    //        fileName += '.geojson';
    //    }

    //    if (layer.getLayers().length > 0) {
    //        var item = new GSI.SakuzuListItem(
	//			this, GSI.SakuzuListItem.GEOJSON, fileName, fileName, layer, true);
    //        this._list.push(item);
    //        return item;
    //    }

    //    else return null;
    //},
    _loadKML: function (fileName, text) {
        var xmlDoc = null;
        if (window.ActiveXObject) {
            xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
            xmlDoc.async = false;
            xmlDoc.loadXML(text ? text : this._fileReader.result);
        }
        else if (window.DOMParser) {
            xmlDoc = new DOMParser().parseFromString(
			   text ? text : this._fileReader.result,
			  "application/xml"
			  );
        }
        var layer = new GSI.KML(null, { async: true });

        layer._addKML(xmlDoc, {});

        if (!fileName) {
            fileName = "file-" + this._list.length + ".kml";
        }
        else if (!fileName.match(/\./)) {
            fileName += '.kml';
        }

        if (layer.getLayers().length > 0) {
            var item = new GSI.SakuzuListItem(
				this, GSI.SakuzuListItem.KML, fileName, fileName, layer, true);

            this._list.push(item);
            return item;
        }
        else return null;

    },
    _styleId: 1,
    getStyleId: function () {
        var result = this._styleId;
        this._styleId++;

        return result;
    },
    toKML: function () {
        this._styleId = 1;

        var styleList = {};
        var result = '';

        for (var i = 0; i < this._list.length; i++) {
            var item = this._list[i];
            // 【地理院地図ソース変更】作図のみをKML出力する、非表示でも出力
            //if (item.getVisible()) {
                if (item._title == GSI.TEXT.SAKUZU.SAKUZUTITLE) {
                    result += item.toKML(styleList);
                }
            //}
        }
        if (result != '') {
            result =
				'<?xml version="1.0" encoding="UTF-8"?>' + "\n" +
				'<kml xmlns="http://www.opengis.net/kml/2.2">' + "\n" +
				'<Document>\n' +
				result +
				'</Document>\n' +
				'</kml>';
        }
        return result;
    },
    //getGeoJSONList: function () {
    //    this._styleId = 1;
    //    var result = [];

    //    for (var i = 0; i < this._list.length; i++) {
    //        var item = this._list[i];
    //        var resultItem = {
    //            fileName: item.getFileName(),
    //            visible: item.getVisible(),
    //            features: item.toGeoJSON()
    //        };
    //        result.push(resultItem);
    //    }

    //    return result;
    //},
    //toGeoJSON: function () {
    //    this._styleId = 1;
    //    var result = {
    //        "type": "FeatureCollection",
    //        "features": []
    //    };
    //    for (var i = 0; i < this._list.length; i++) {
    //        var item = this._list[i];
    //        if (item.getVisible()) {
    //            var features = item.toGeoJSON();

    //            for (var j = 0; j < features.length; j++) {
    //                result.features.push(features[j]);
    //            }
    //        }
    //    }

    //    return JSON.stringify(result, null, "  ");
    //},
    //getData: function () {
    //    var result = [];
    //    for (var i = 0; i < this._list.length; i++) {
    //        var item = this._list[i];
    //        if (item.getVisible()) {
    //            var features = item.toGeoJSON();
    //            for (var j = 0; j < features.length; j++) {
    //                result.push(features[j]);
    //            }
    //        }
    //    }

    //    return result;
    //}
});

/************************************************************************
 L.FeatureGroup
 - GSI.KML
 ************************************************************************/
GSI.KML = L.FeatureGroup.extend({
    options: {
        async: true
    },
    opacitySetter: new GSI.LayerOpacitySetter(),
    initialize: function (kml, options) {
        L.Util.setOptions(this, options);
        this._kml = kml;
        this._layers = {};
    },
//    load: function () {
//        if (this._kml) {
//            this.addKML(this._kml, this.options, this.options.async);
//        }
//    },
//    loadXML: function (url, cb, options, async) {
//        if (async === undefined) async = this.options.async;
//        if (options === undefined) options = this.options;

//        if (this.options._map) {
//            var bounds = this.options._map.getBounds();
//            url = url.replace('{left}', bounds.getWest());
//            url = url.replace('{top}', bounds.getNorth());
//            url = url.replace('{right}', bounds.getEast());
//            url = url.replace('{bottom}', bounds.getSouth());
//        }

//        $.support.cors = true;
//        this.ajax = $.ajax({
//            type: "GET",
//            dataType: "xml",
//            url: url,
//            success: L.Util.bind(this._onKMLLoad, this),
//            error: L.Util.bind(this._onKMLLoadError, this),
//            async: async

//        });
//    },
//    onAdd: function (map) {
//        this._map = map;
//        this._map.on('zoomend', this._onZoomChange, this);
//        this._onZoomChange();
//    },
//    onRemove: function (map) {
//        if (map) map.off('zoomend', this._onZoomChange, this);
//        this.eachLayer(map.removeLayer, map);
//        this._map = null;
//        this._layerAdded = false;
//    },
    _onZoomChange: function () {
        if (!this._map) return;
        var zoom = this._map.getZoom();

        if (
			(this.options.minZoom && this.options.minZoom > zoom)
				||
			(this.options.maxZoom && this.options.maxZoom < zoom)
		) {
            this._layerAdded = false;
            this.eachLayer(this._map.removeLayer, this._map);
        }
        else {
            if (!this._layerAdded) {
                this._layerAdded = true;
                this.eachLayer(this._map.addLayer, this._map);
            }
        }
    },
//    _onKMLLoadError: function (e) {
//        this.fire('loaded');
//    },
//    _onKMLLoad: function (result) {
//        var data = null;
//        if (!result) return;

//        if (result.data) {
//            try {
//                if (window.ActiveXObject) {
//                    data = new ActiveXObject("Microsoft.XMLDOM");
//                    data.async = false;
//                    data.loadXML($.trim(result.data));
//                }
//                else if (window.DOMParser) {
//                    data = new DOMParser().parseFromString(
//						$.trim(result.data),
//						"application/xml"
//					);
//                }
//            }
//            catch (e) {
//                data = null;
//            }
//        }
//        else data = result;

//        if (!data) {
//            this.fire('loaded');
//        }
//        else {
//            try {
//                this._addKML(data, this.options);
//            }
//            catch (e) {
//                this.fire('loaded');
//            }
//        }
//    },
//    addKML: function (url, options, async) {
//        var _this = this;
//        this.fire('loadstart');

//        try {
//            this.loadXML(url, null, options, async);
//        }
//        catch (e) {
//            this.fire('loaded');
//        }
//    },
//    setMarkerZIndex: function (zIndex) {

//        this.options.zIndexOffset = zIndex;
//        L.FeatureGroup.prototype.setMarkerZIndex.call(this, this.options.zIndexOffset);
//    },
    _addKML: function (xml, options) {

        try {
            var layers = GSI.KML.parseKML(xml);

            if (!layers || !layers.length) {
                this.fire('loaded');
                return;
            }
            for (var i = 0; i < layers.length; i++) {
                this.fire('addlayer', {
                    layer: layers[i]
                });

                this.addLayer(layers[i]);
            }

            if (this.options.zIndexOffset) {
                this.setMarkerZIndex(this.options.zIndexOffset);
            }

            this.latLngs = GSI.KML.getLatLngs(xml);
            if (this.opacity) {
                this.setOpacity(this.opacity);
            }
        }
        catch (e) { }
        try {
            this.fire('loaded');
        } catch (e) { }
        this._onZoomChange();
    },
    setOpacity: function (opacity) {
        this.opacity = opacity;

        this.eachLayer(L.bind(function (layer) {

            this.opacitySetter.setOpacity(layer, this.opacity);

        }, this));
    },
    latLngs: []
});

L.Util.extend(GSI.KML, {

    parseKML: function (xml) {
        var style = this.parseStyle(xml);
        this.parseStyleMap(xml, style);
        var el = xml.getElementsByTagName('Folder');
        var layers = [], l;
        for (var i = 0; i < el.length; i++) {
            if (!this._check_folder(el[i])) { continue; }
            l = this.parseFolder(el[i], style);
            if (l) { layers.push(l); }
        }
        el = xml.getElementsByTagName('Placemark');
        for (var j = 0; j < el.length; j++) {
            if (!this._check_folder(el[j])) { continue; }
            l = this.parsePlacemark(el[j], xml, style);
            if (l) { layers.push(l); }
        }
        return layers;
    },
    // Return false if e's first parent Folder is not [folder]
    // - returns true if no parent Folders
    _check_folder: function (e, folder) {

        e = (e.parentElement ? e.parentElement : e.parentNode);

        while (e && e.tagName !== 'Folder') {
            e = (e.parentElement ? e.parentElement : e.parentNode);
        }
        return !e || e === folder;
    },
    parseStyle: function (xml) {
        var style = {};
        var sl = xml.getElementsByTagName('Style');

        //for (var i = 0; i < sl.length; i++) {
        var attributes = {
            color: true, width: true, Icon: true, href: true,
            hotSpot: true, scale: true
        };

        function _parse(xml) {
            var options = {};
            for (var i = 0; i < xml.childNodes.length; i++) {
                var e = xml.childNodes[i];
                var key = e.tagName;

                if (!attributes[key]) { continue; }
                if (key === 'hotSpot') {
                    for (var j = 0; j < e.attributes.length; j++) {
                        options[e.attributes[j].name] = e.attributes[j].nodeValue;
                    }
                } else {
                    var value = e.childNodes[0].nodeValue;
                    if (key === 'color') {
                        options.opacity = parseInt(value.substring(0, 2), 16) / 255.0;
                        options.color = '#' + value.substring(6, 8) + value.substring(4, 6) + value.substring(2, 4);
                    } else if (key === 'width') {
                        options.weight = value;
                    } else if (key === 'Icon') {
                        ioptions = _parse(e);
                        if (ioptions.href) { options.href = ioptions.href; }
                    } else if (key === 'href') {
                        options.href = value;
                    } else if (key === 'scale') {
                        options.scale = value;
                    }
                }
            }
            return options;
        }

        for (var i = 0; i < sl.length; i++) {
            var e = sl[i], el;
            var options = {}, poptions = {}, ioptions = {};
            el = e.getElementsByTagName('LineStyle');
            if (el && el[0]) { options = _parse(el[0]); }
            el = e.getElementsByTagName('PolyStyle');
            if (el && el[0]) { poptions = _parse(el[0]); }
            if (poptions.color) { options.fillColor = poptions.color; }
            if (poptions.opacity || poptions.opacity == 0) { options.fillOpacity = poptions.opacity; }
            el = e.getElementsByTagName('IconStyle');
            if (el && el[0]) { ioptions = _parse(el[0]); }
            if (ioptions.href) {
                // save anchor info until the image is loaded
                options.icon = new GSI.KMLIcon({
                    iconUrl: ioptions.href,
                    shadowUrl: null,
                    iconAnchorRef: { x: ioptions.x, y: ioptions.y },
                    iconAnchorType: { x: ioptions.xunits, y: ioptions.yunits },
                    _iconScale: ioptions.scale
                });
            }
            style['#' + e.getAttribute('id')] = options;
        }
        return style;
    },
    parseStyleMap: function (xml, existingStyles) {
        var sl = xml.getElementsByTagName('StyleMap');

        for (var i = 0; i < sl.length; i++) {
            var e = sl[i], el;
            var smKey = '', smStyleUrl = '';

            el = e.getElementsByTagName('key');
            if (el && el[0]) { smKey = el[0].textContent; }
            el = e.getElementsByTagName('styleUrl');
            if (el && el[0]) { smStyleUrl = el[0].textContent; }

            if (smKey === 'normal') {
                existingStyles['#' + e.getAttribute('id')] = existingStyles[smStyleUrl];
            }
        }

        return;
    },
    parseFolder: function (xml, style) {
        var el, layers = [], l;
        el = xml.getElementsByTagName('Folder');
        for (var i = 0; i < el.length; i++) {
            if (!this._check_folder(el[i], xml)) { continue; }
            l = this.parseFolder(el[i], style);
            if (l) { layers.push(l); }
        }
        el = xml.getElementsByTagName('Placemark');
        for (var j = 0; j < el.length; j++) {
            if (!this._check_folder(el[j], xml)) { continue; }
            l = this.parsePlacemark(el[j], xml, style);
            if (l) { layers.push(l); }
        }
        if (!layers.length) { return; }
        return new L.FeatureGroup(layers);
    },
    parsePlacemark: function (place, xml, style) {
        var i, j, el, options = {};
        el = place.getElementsByTagName('styleUrl');
        for (i = 0; i < el.length; i++) {
            var url = el[i].childNodes[0].nodeValue;
            for (var a in style[url]) {
                options[a] = style[url][a];
            }
        }
        var layers = [];
        var parse = ['LineString', 'Polygon', 'Point'];

        for (j in parse) {
            // for jshint
            if (true) {
                var tag = parse[j];
                if (tag && typeof tag == 'string') {
                    el = place.getElementsByTagName(tag);
                    for (i = 0; i < el.length; i++) {
                        var l = this['parse' + tag](el[i], xml, options);
                        if (l) { layers.push(l); }
                    }
                }
            }
        }

        if (!layers.length) {
            return;
        }
        var layer = layers[0];
        if (layers.length > 1) {
            layer = new L.FeatureGroup(layers);
        }

        var name, tbl = '', descr = '';
        el = place.getElementsByTagName('name');
        if (el.length && el[0].childNodes.length) {
            name = el[0].childNodes[0].nodeValue;
        }
        el = place.getElementsByTagName('description');
        for (i = 0; i < el.length; i++) {
            for (j = 0; j < el[i].childNodes.length; j++) {
                descr = descr + el[i].childNodes[j].nodeValue;
            }
        }

        layer._information = {
            title: (name && name != '' ? name : null),
            description: (descr && descr != '' ? descr : null),
            table: null
        };

        if (layer._information.description) {
            // parse table tag
            var parser = $('<div>').html(layer._information.description);

            var table = parser.children('table');

            if (table.length > 0) {
                var tr = $(table[0]).find('tr');

                if (tr.length <= 0) {
                    tr = $(table[0]).chidlren('tbody').children('tr');
                }
                for (var i = 0; i < tr.length; i++) {
                    var td = $(tr[i]).children('td');
                    if (td.length == 2) {
                        if (!layer._information.table) layer._information.table = [];
                        layer._information.table.push({ key: $(td[0]).html(), value: $(td[1]).html() });
                    }
                    else {
                        layer._information.table = null;
                        break;
                    }
                }
            }

            delete parser;
            parser = null;
        }

        if (layer._information.table) layer._information.description = null;

        if ((name && name != '') || (descr && descr != '')) {
            layer.bindPopup((name && name != '' ? '<h2>' + GSI.Utils.encodeHTML(name) + '</h2>' : '') + (descr && descr != '' ? descr : ''),
					{
					    maxWidth: 5000
					});
        }

        return layer;
    },
    parseCoords: function (xml) {
        var el = xml.getElementsByTagName('coordinates');
        return this._read_coords(el[0]);
    },
    parseLineString: function (line, xml, options) {
        var coords = this.parseCoords(line);
        if (!coords.length) { return; }
        return new L.Polyline(coords, options);
    },
    parsePoint: function (line, xml, options) {
        var el = line.getElementsByTagName('coordinates');
        if (!el.length) {
            return;
        }
        var ll = el[0].childNodes[0].nodeValue.split(',');
        return new GSI.KMLMarker(new L.LatLng(ll[1], ll[0]), options);
    },
    parsePolygon: function (line, xml, options) {
        var el, polys = [], inner = [], i, coords;
        el = line.getElementsByTagName('outerBoundaryIs');
        for (i = 0; i < el.length; i++) {
            coords = this.parseCoords(el[i]);
            if (coords) {
                polys.push(coords);
            }
        }
        el = line.getElementsByTagName('innerBoundaryIs');
        for (i = 0; i < el.length; i++) {
            coords = this.parseCoords(el[i]);
            if (coords) {
                inner.push(coords);
            }
        }
        if (!polys.length) {
            return;
        }
        if (options.fillColor) {
            options.fill = true;
        }
        if (polys.length === 1) {
            return new L.Polygon(polys.concat(inner), options);
        }
        return new L.MultiPolygon(polys, options);
    },
    getLatLngs: function (xml) {
        var el = xml.getElementsByTagName('coordinates');
        var coords = [];
        for (var j = 0; j < el.length; j++) {
            // text might span many childNodes
            coords = coords.concat(this._read_coords(el[j]));
        }
        return coords;
    },
    _read_coords: function (el) {
        var text = '', coords = [], i;
        for (i = 0; i < el.childNodes.length; i++) {
            text = text + el.childNodes[i].nodeValue;
        }
        text = text.split(/[\s\n]+/);
        for (i = 0; i < text.length; i++) {
            var ll = text[i].split(',');
            if (ll.length < 2) {
                continue;
            }
            coords.push(new L.LatLng(ll[1], ll[0]));
        }
        return coords;
    }
});

GSI.KMLIcon = L.Icon.extend({

    createIcon: function () {
        var img = this._createIcon('icon');

        if (img.width && img.width > 0) {
            this._onIconImageLoaded(img);
        }
        else {
            $(img).css({ 'visibility': 'hidden' }).on('load', L.bind(this._onIconImageLoaded, this, img));
        }
        return img;
    },
    _onIconImageLoaded: function (img) {
        var scale = (this.options._iconScale ? this.options._iconScale : 1);
        var w = Math.round(img.width * scale);
        var h = Math.round(img.height * scale);
        this.options.iconSize = [w, h];
        var anchorX = null;
        var anchorY = null;
        if (this.options.iconAnchorRef && this.options.iconAnchorRef.x) {
            anchorX = Math.round(w * this.options.iconAnchorRef.x);
        }
        else {
            anchorX = Math.round(w / 2);
        }

        if (this.options.iconAnchorRef && this.options.iconAnchorRef.y) {
            anchorY = Math.round(h * this.options.iconAnchorRef.y);
        }
        else {
            anchorY = Math.round(h / 2);
        }
        this.options.iconAnchor = [anchorX, anchorY];

        this._setIconStyles(img, "icon");
        L.DomUtil.addClass(img, 'leaflet-clickable');
        img.style.visibility = 'visible';
    }
});


GSI.KMLMarker = L.Marker.extend({
    options: {
        icon: new GSI.KMLIcon.Default(),
        clickable: true
    }
});
